// ImgCopy.cpp : Defines the entry point for the console application.
//
// Copy image in the Clipboard.
// This program use CxImages library.
//
#include <olectl.h>
#include <ole2.h>
#include "stdafx.h"
#include "ImgCopy.h"
#include "CxImage/ximage.h"
#include "CxImage/ximaraw.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define MAX_ARGS 2
/////////////////////////////////////////////////////////////////////////////
// The one and only application object

CWinApp theApp;

using namespace std;

CString FindExtension(const CString& name)
{
	int len = name.GetLength();
	int i;
	for (i = len-1; i >= 0; i--){
		if (name[i] == '.'){
			return name.Mid(i+1);
		}
	}
	return CString(_T(""));
}

int FindType(const CString& ext)
{
	return CxImage::GetTypeIdFromName(ext);
}

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}
	else
	{
		if (argc < 2)
		{
			cerr << _T("Error: No image file supplied") << endl;
			return nRetCode=1;
		}
		
		if (argc > MAX_ARGS)
			cerr << _T("Warning: Too many files supplied. Only first would be processed") << endl;

		char* filename = argv[1];
		filename = _fullpath(NULL, filename, MAX_PATH);

		CString file = _T(filename);
		CString ext(FindExtension(file));
		ext.MakeLower();
		if (ext == _T("")) return nRetCode=1;

		int type = FindType(ext);

		CxImage* image = new CxImage(file, type);

		if (_tcsnicmp(ext,_T("emf"),3)==0 )
		{
			OpenClipboard(GetDesktopWindow());
			EmptyClipboard();
			HENHMETAFILE handle = GetEnhMetaFile( argv[1] );
			SetClipboardData(CF_ENHMETAFILE,handle);
			CloseClipboard();
		}else{
			// standard DIB image
			HANDLE hDIB=image->CopyToHandle();


			//custom CXIMAGE object
			/*HANDLE hMem=NULL;
			if (image->IsValid())
			{
				hMem= GlobalAlloc(GHND, image->DumpSize());
				if (hMem)
				{
					BYTE* pDst=(BYTE*)GlobalLock(hMem);
					image->Dump(pDst);
					GlobalUnlock(hMem);
				}
			}*/

			if (::OpenClipboard(NULL) )
			{
				if(::EmptyClipboard()) 
				{
					if (::SetClipboardData(CF_DIB,hDIB) == NULL ) {
						AfxMessageBox( _T("Unable to set DIB clipboard data") );
					}
					/* (hMem)
					{
						UINT cf = 0;
						if (::SetClipboardData(cf,hMem) == NULL ) 
						{
							AfxMessageBox( _T("Unable to set CXIMAGE clipboard data") );
						}
					}*/
				}
			}
			CloseClipboard();
		}

		delete image;
	}
	return nRetCode;
}


